#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   runParallelDialog.py
#
#       並列計算の設定、実行
#
#   12/04/30    新規作成
#      11/02    バグ修正（接続状態確認時、currentDirを設定する様に変更）
#      12/09    multiRegionの分割方法、結果再構築方法を変更
#   13/01/11    メッセージ内容を修正
#      01/19    multiRegionの場合のreconstructParを修正
#      03/16    regionPropertiesの有無でmultiRegionかどうかを判定する様に修正
#      05/09    分割後、timeFolder内にmeshをコピーするように修正
#      05/23    decompose,reconstructでzone取得にバグあり、修正
#      10/15    国際化のため、修正
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   14/11/13    decompose, reconstruct:OF-2.3以上で処理変更
#      11/30    couplingPatchの設定を追加
#      12/02    initialize:decomposeParDict有無、regionCouplingPatchを取得追加
#      12/03    couplingPatch部分を削除
#      12/05    initialize:ﾊﾞｸﾞ修正
#      12/13    runDecomposePar:「-constant」optionを削除
#

# generated by wxGlade 0.6.3 on Mon Apr 30 10:37:28 2012

import wx
import os
import sys
import glob

import setFoamContents
import getFoamContents
import pyTreeFoam
#import decomposeSetCouplingPatchDDialog
from fileOperationInProcessorDialog import Show as fileOperationInProcessor
from fileOperationInRegionDialog import Show as fileOperationInRegionDialogShow
from treefoam import machinesFile as treefoamMachinesFile

import logFileCreater; logFileCreater.log()


caseDir = ""
regionPatches = []
regionCouplingPatches = []

# begin wxGlade: extracode
# end wxGlade



def Show(caseDir1):
    global caseDir
    caseDir = caseDir1
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"並列計算の設定、計算開始"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"machines編集"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"接続状態の確認"))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u"並列計算するsubDomainを定義。\n（/etc/hostsで定義されているhostから選択）"))
        self.sizer_6_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"machines作成"))
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _("nCPU:"))
        self.text_ctrl_1 = wx.TextCtrl(self, wx.ID_ANY, "", style=wx.TE_RIGHT)
        self.label_9 = wx.StaticText(self, wx.ID_ANY, _(u"並列計算させる為のcpu数を設定"))
        self.button_10 = wx.Button(self, wx.ID_ANY, _(u"Dict作成"))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"Dict確認・編集"))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _(u"各cpu毎のmesh分割方法を定義。"))
        self.sizer_16_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"deconposeParDict作成"))
        self.sizer_2_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"設定ファイルの作成"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _(u"mesh分割"))
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"各領域のfile操作"))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(u"cpu毎に領域分割、node毎に領域配布"))
        self.sizer_10_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"領域分割"))
        self.checkbox_1 = wx.CheckBox(self, wx.ID_ANY, _(u"machinesファイルを使用する"))
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"並列計算開始"))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"lam(mpi)の停止"))
        self.label_5 = wx.StaticText(self, wx.ID_ANY, _(u"並列計算を開始します（mpirun）"))
        self.sizer_4_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"並列計算"))
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"結果の再構築"))
        self.button_12 = wx.Button(self, wx.ID_ANY, _(u"各領域のfile操作"))
        self.label_6 = wx.StaticText(self, wx.ID_ANY, _(u"実行後、cpu毎の計算結果を集め、結果を再構築します。"))
        self.sizer_12_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"結果の確認"))
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onEditMachines, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onCheckNodes, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onCreateDecomposeParDict, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onEditDecomposeParDict, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onDecomposePar, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onFileOperation, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onRunMpi, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onHaltMpi, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onReconstruct, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onFileOperation, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_9)
        # end wxGlade

        self.initialize()

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"並列計算"))
        self.button_1.SetMinSize((130, 30))
        self.button_10.SetMinSize((130, 30))
        self.button_4.SetMinSize((130, 30))
        self.button_5.SetMinSize((130, 30))
        self.button_7.SetMinSize((130, 30))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_12_staticbox.Lower()
        sizer_12 = wx.StaticBoxSizer(self.sizer_12_staticbox, wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_4_staticbox.Lower()
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_10_staticbox.Lower()
        sizer_10 = wx.StaticBoxSizer(self.sizer_10_staticbox, wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_2_staticbox.Lower()
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.VERTICAL)
        self.sizer_16_staticbox.Lower()
        sizer_16 = wx.StaticBoxSizer(self.sizer_16_staticbox, wx.VERTICAL)
        sizer_18 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_17 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_6_staticbox.Lower()
        sizer_6 = wx.StaticBoxSizer(self.sizer_6_staticbox, wx.VERTICAL)
        sizer_15 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_15.Add(self.button_1, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_15.Add(self.button_2, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_6.Add(sizer_15, 0, wx.EXPAND, 0)
        sizer_6.Add(self.label_2, 0, wx.LEFT, 20)
        sizer_2.Add(sizer_6, 0, wx.ALL | wx.EXPAND, 5)
        sizer_17.Add(self.label_7, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 7)
        sizer_17.Add(self.text_ctrl_1, 0, wx.LEFT, 0)
        sizer_17.Add(self.label_9, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_16.Add(sizer_17, 0, wx.EXPAND, 0)
        sizer_18.Add(self.button_10, 0, wx.LEFT, 5)
        sizer_18.Add(self.button_3, 0, wx.LEFT, 15)
        sizer_16.Add(sizer_18, 0, wx.EXPAND, 0)
        sizer_16.Add(self.label_3, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_2.Add(sizer_16, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_1.Add(sizer_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_11.Add(self.button_4, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_11.Add(self.button_8, 0, wx.LEFT, 10)
        sizer_10.Add(sizer_11, 0, wx.EXPAND, 0)
        sizer_7.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_10.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_10, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_8.Add(self.checkbox_1, 0, wx.LEFT, 10)
        sizer_4.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_5.Add(self.button_5, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_5.Add(self.button_6, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_4.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_4.Add(self.label_5, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_4, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_13.Add(self.button_7, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_13.Add(self.button_12, 0, wx.LEFT, 10)
        sizer_12.Add(sizer_13, 0, wx.EXPAND, 0)
        sizer_12.Add(self.label_6, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_12, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_14.Add(self.button_9, 0, wx.ALL | wx.ALIGN_RIGHT, 10)
        sizer_9.Add(sizer_14, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_9, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #machines編集
    def onEditMachines(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：machinesを編集します。")
        self.editMachines()
        event.Skip()

    #接続状態の確認
    def onCheckNodes(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：接続状態を確認します。")
        self.checkConnectedNodes()
        event.Skip()

    #couplingPatchの設定
    #def onSetCouplingPatch(self, event):  # wxGlade: MyFrame.<event_handler>
    #    self.setCouplingPatch()

    #Dict作成
    def onCreateDecomposeParDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.createDecomposeParDict(event)

    #decomposeParDict編集
    def onEditDecomposeParDict(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：decomposeParDictを編集します。")
        self.editDecomposeParDict()

    #メッシュ分割
    def onDecomposePar(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：メッシュを分割します。")
        self.runDecomposePar()

    #メッシュ分配
    def onDistToNode(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `onDistToNode' not implemented!"
        event.Skip()

    #processor内のfile操作
    def onFileOperation(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"processor内のfile操作")
        self.fileOperation()
        event.Skip()

    #並列計算開始
    def onRunMpi(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算を開始します。")
        self.runMpi()

    def onHaltMpi(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"lam, mpiを停止します。")
        self.haltMpi()
        event.Skip()

    def onReconstruct(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"結果を集め再構築します。")
        self.reconstruct()
        event.Skip()

    #Close
    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        self.Destroy()
        event.Skip()

    #  initialize
    #    初期化
    def initialize(self):
        global nCpu, caseDir, regionCouplingPatches
        #decomposeParDict確認
        [fluids, solids] = pyTreeFoam.getZonesInRegionProperties(caseDir)
        regions = ["."] + fluids + solids
        regions.sort()
        sourceFileName = caseDir + "/system/decomposeParDict"
        if len(glob.glob(sourceFileName)) == 0:
            cont = setFoamContents.makeDecomposeParDictDefault()
            f=open(sourceFileName, "w"); f.write(cont); f.close()
        flag = 0
        for region in regions:
            fileName = caseDir + "/system/" + region + "/decomposeParDict"
            if len(glob.glob(fileName)) == 0:
                comm = "cp " + sourceFileName + " " + fileName
                os.system(comm)
                flag = 1
        if flag == 1:
            msg = _(u"deconposeParDictが無かったので、標準のdecomposeParDictを作成しました。")
            self.okDialog(_(u"decomposeParDictの編集"), msg)
        #nCpuを読み込み
        f=open(sourceFileName); cont=f.read(); f.close()
        [lineCont, p, kind] = getFoamContents.get1lineMem(cont, 0)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        while lineCont != "" and keyword != "numberOfSubdomains":
            [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        if keyword == "numberOfSubdomains":
            nCpu = lineCont[:-1].split()[1]
            self.text_ctrl_1.SetValue(nCpu)
        """
        #regionCouplingPatchesを取得
        regionCouplingPatches = []
        for region in regions:
            couplingPatch = getRegionCouplingPatch(caseDir, region)
            couplingPatch.sort()
            regionCouplingPatches.append([region, couplingPatch])
        """

    """
    #  setCouplingPatch
    #    couplingPatchを設定する
    def setCouplingPatch(self):
        global regionPatches, regionCouplingPatches
        #regionPatchesの設定
        regionPatches = []
        [fluids, solids] = pyTreeFoam.getZonesInRegionProperties(caseDir)
        regions = ["."] + fluids + solids
        regions.sort()
        currTime = getFoamContents.getCurrTimeFolder(caseDir)
        for region in regions:
            relPolyMeshDir = getFoamContents.getCurrMeshDir(caseDir, currTime,
                region, "boundary")
            polyMeshDir = caseDir + "/" + relPolyMeshDir
            patchConts = getFoamContents.getPatchNameFromBoundary(polyMeshDir)
            patches = []
            for patchCont in patchConts:
                patches.append(patchCont[0])
            patches.sort()
            regionPatches.append([region, patches])
        #regionCoupligPatchesの取得
        regionCouplingPatches = []
        for region in regions:
            couplingPatch = getRegionCouplingPatch(caseDir, region)
            couplingPatch.sort()
            regionCouplingPatches.append([region, couplingPatch])
        #regionCoupligPatchesを再設定
        regionCouplingPatches = decomposeSetCouplingPatchDDialog.Show(caseDir,
                regionPatches, regionCouplingPatches)
    """


    #  editMachies
    #    machinesの編集
    def editMachines(self):
        global caseDir
        machinesFile = treefoamMachinesFile
        fileName = caseDir + "/" + machinesFile
        if len(glob.glob(fileName)) == 0:
            cont = setFoamContents.makeMachinesDefault()
            f=open(fileName,"w"); f.write(cont); f.close()
            msg = _(u"machinesがなかったので、標準の「machines」を作成しました。\n 「localhost cpu=4」で作成しています。")
            self.okDialog(_(u"並列計算"), msg)
        pyTreeFoam.runEditor(fileName)

    #  checkConnectedNodes
    #    接続状態を確認
    def checkConnectedNodes(self):
        global caseDir
        machinesFile = treefoamMachinesFile
        fileName = caseDir + "/" + machinesFile
        if len(glob.glob(fileName)) == 0:
            title = _(u"nodeの表示")
            message = _(u"現在の解析Case内に「mashines」ファイルがありません。\n「machines」で並列計算させるノードを設定してください。")
            self.errDialog(title, message)
            return
        tempFile = caseDir + "/nodes.temp"
        command = "cd " + caseDir + ";lamboot -v machines; lamnodes | tee " + tempFile + "; lamhalt -d"
        pyTreeFoam.runOFUtility(command)
        f=open(tempFile); cont=f.read(); f.close()
        message = _(u"接続されているノードを表示します。\n\nnode\t内容\n-------------------------------------\n") + cont
        os.system("rm -rf " + tempFile)
        title = _(u"nodeの表示")
        self.okDialog(title, message)

    #  createDecomposeParDict
    #    decomposeParDict作成
    def createDecomposeParDict(self, event):
        global caseDir, nCpu, regionPatches, regionCouplingPatches
        #nCpu設定
        nCpu = self.text_ctrl_1.GetValue()
        #systemフォルダ直下を書き換え
        fileName = caseDir + "/system/decomposeParDict"
        f=open(fileName); cont=f.read(); f.close()
        newLine = "numberOfSubdomains " + nCpu + ";"
        [cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0, newLine)
        f=open(fileName, "w"); f.write(cont); f.close()
        mess = _(u"decomposeParDictを書き換えました。")
        [fluids, solids] = pyTreeFoam.getZonesInRegionProperties(caseDir)
        if len(fluids) > 0 or len(solids) > 0:
            #region内を書き換え
            regions = fluids + solids
            sourceFileName = caseDir + "/system/decomposeParDict"
            for region in regions:
                fileName = caseDir + "/system/" + region + "/decomposeParDict"
                if len(glob.glob(fileName)) == 0:
                    comm = "cp " + sourceFileName + " " + fileName
                    print comm
                    os.system(comm)
                f=open(fileName); cont=f.read(); f.close()
                newLine = "numberOfSubdomains " + nCpu + ";"
                [cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0, newLine)
                f=open(fileName, "w"); f.write(cont); f.close()
            #fluidRegionsを書き換え
            files = glob.glob(caseDir + "/system/fluidRegions/decomposeParDict*")
            for fileName in files:
                name = fileName.split("/")[-1].split(".")[0]
                if name == "decomposeParDict":
                    f=open(fileName); cont=f.read(); f.close()
                    newLine = "numberOfSubdomains " + nCpu + ";"
                    [cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0,
                        newLine)
                    f=open(fileName, "w"); f.write(cont); f.close()
            #solidRegionsを書き換え
            files = glob.glob(caseDir + "/system/solidRegions/decomposeParDict*")
            for fileName in files:
                name = fileName.split("/")[-1].split(".")[0]
                if name == "decomposeParDict":
                    f=open(fileName); cont=f.read(); f.close()
                    newLine = "numberOfSubdomains " + nCpu + ";"
                    [cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0,
                        newLine)
                    f=open(fileName, "w"); f.write(cont); f.close()
            mess = _(u"各region毎にdecomposeParDictを書き換えました。")
        #coupingPatchesを修正
        #setDecomposeCouplingPatch(caseDir, regionCouplingPatches)
        title = _(u"decopmposeParDictの作成")
        print mess
        self.okDialog(title, mess)

    #  editDecomposeParDict
    #    decomposeParDictを編集する
    def editDecomposeParDict(self):
        global caseDir
        [fluids, solids] = pyTreeFoam.getZonesInRegionProperties(caseDir)
        if len(fluids) == 0 and len(solids) == 0:
            #シングルregionの場合 
            fileName = caseDir + "/system/decomposeParDict"
            if len(glob.glob(fileName)) == 0:
                cont = setFoamContents.makeDecomposeParDictDefault()
                f=open(fileName,"w"); f.write(cont); f.close()
                msg = _(u"deconposeParDictが無かったので、標準のdecomposeParDictを作成しました。")
                self.okDialog(_(u"decomposeParDictの編集"), msg)
            pyTreeFoam.runEditor(fileName) 
        else:
            #multiRegionの場合
            os.chdir(caseDir)
            fileOperationInRegionDialogShow("2")

    #  runDecomposePar
    #    meshをcpu毎に分割
    def runDecomposePar(self):
        global caseDir
        fileName = caseDir + "/system/decomposeParDict"
        if len(glob.glob(fileName)) == 0:
            title = _(u"エラー")
            message = _(u"systemフォルダ内に「decomposeParDict」がありません。\n作成した上で実行してください。")
            self.errDialog(title, message)
            return

        saveDir = os.getcwd()
        os.chdir(caseDir)
        #既に分割ファイルがある場合は、削除する
        processorfile = caseDir + "/processor*"
        nCPU = len(glob.glob(caseDir + "/processor*"))
        if nCPU != 0:
            while nCPU > 0:
                cpuName = str(nCPU-1)
                command = "rm -rf processor" + cpuName
                print command
                os.system(command)
                nCPU -= 1
        #領域分割
        OFversion = pyTreeFoam.readConfigTreeFoam()[0]
        if OFversion >= "2.3.0":
            #OF-2.30以上
            if len(glob.glob("./constant/regionProperties")) != 0:
                #multiRegion場合
                #comm = "decomposePar -allRegions -constant"
                comm = "decomposePar -allRegions"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                message = _(u"cpu > region 毎にメッシュを分割しました。")
            else:
                #singleRegionの場合
                #comm = "decomposePar -constant"
                comm = "decomposePar"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                message = _(u"cpu 毎にメッシュを分割しました。")

        else:
            #OF-2.2以下
            if len(glob.glob("./constant/regionProperties")) != 0:
                #multiRegion場合
                [fluid, solid] = pyTreeFoam.getZonesInRegionProperties(caseDir)
                zones = fluid + solid
                for zone in zones:
                    comm = "decomposePar -region " + zone
                    print comm
                    [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                    if stat != "OK":
                        break
                message = _(u"cpu > region 毎にメッシュを分割しました。")
            else:
                #singleRegionの場合
                comm = "decomposePar"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                message = _(u"cpu 毎にメッシュを分割しました。")

        if stat != "OK":
            title = _(u"エラー")
            message = _(u"エラーが発生しました。\n　logを確認してください。")
            self.errDialog(title, message)
        else:
            title = _(u"並列計算")
            self.okDialog(title, message)
        os.chdir(saveDir)

    #
    #  distMeshTimeFolderRegion
    #    分割したmeshをtimeFolderにコピーする
    def distMeshTimeFolderRegion(self, caseDir, zones):
        times = pyTreeFoam.getTimeFolders(caseDir)
        if len(times) == 0:
            return "NG"

        nPro = len(glob.glob(caseDir + "/processor*"))
        timeFolder = times[0]
        i=0
        while i<nPro:
            for zone in zones:
                copyDir = caseDir + "/processor" + str(i) + "/constant/" + zone + "/polyMesh"
                distDir = caseDir + "/processor"+str(i)+"/" + timeFolder + "/" + zone
                if len(glob.glob(copyDir)) != 0:
                    comm = "cp -r " + copyDir + " " + distDir
                    os.system(comm)
            i += 1
        return "OK"

    #  distMeshTimeFolder
    #    分割したmeshをtimeFolderにコピーする。
    def distMeshTimeFolder(self, caseDir):
        times = pyTreeFoam.getTimeFolders(caseDir)
        if len(times) == 0:
            return "NG"

        timeFolder = times[0]
        copyDir = caseDir + "/constant/polyMesh"
        distDir = caseDir + "/" + timeFolder
        if len(glob.glob(copyDir)) != 0:
            comm = "cp -r " + copyDir + " " + distDir
            os.system(comm)
        return "OK"

    #  fileOperation
    #    各processor内のfile操作
    def fileOperation(self):
        global caseDir
        fileOperationInProcessor(caseDir)

    #  runMpi
    #    並列計算開始
    def runMpi(self):
        global caseDir
        solver = pyTreeFoam.getSolver(caseDir)
        nCpu = len(glob.glob(caseDir + "/processor*"))
        if solver != "" and nCpu>1:
            #dir保存
            saveDir = os.getcwd()
            os.chdir(caseDir)
            #solve.logのクリア
            f=open("solve.log", "w"); f.close()
            #machinesを取得
            machines = self.getMachinesData()
            #solverの実行ファイル作成
            envOF = pyTreeFoam.getBashrcFoam()
            cont  = "#!/bin/bash\n"
            cont += ". " + envOF + "\n"
            cont += "lamboot -v machines\n"
            comm = "mpirun" + machines + " -np " + str(nCpu) + " " + solver + " -parallel"
            cont += comm + " | tee solve.log\n"
            f=open("run", "w"); f.write(cont); f.close()
            #実行権付与
            os.system("chmod a+x run")
            #実行
            print comm
            caseName = caseDir.split("/")[-1]
            comm = "gnome-terminal -t " + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run &"
            os.system(comm)
            #dirを元に戻す
            os.chdir(saveDir)
        else:
            title = _(u"エラー")
            if solver == "":
                message = _(u"「controlDict」は、存在しません。\n")
                message += _(u"  case directoryが間違っています。")
            else:
                message = _(u"メッシュが並列計算用に領域分割されていません。") 
            self.okDialog(title, message)

    #  getMachinesData
    #    machinesファイル設定有無確認
    def getMachinesData(self):
        text = ""
        if self.checkbox_1.GetValue() == True:
            fileName = caseDir + "/machines"
            if len(glob.glob(fileName)) != 0:
                text = " -hostfile machines "
            else:
                title = _(u"並列計算")
                mess = _(u"machinesファイルが存在しません。\n")
                mess += _(u"hostのみで並列処理します。")
                print mess
                self.warningDialog(title, mess)
        return text

    #  haltMpi
    #    lam, mpiの中断
    def haltMpi(self):
        global caseDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        comm = "ompi-clean -v; lamhalt -d -v"
        print comm
        pyTreeFoam.runOFUtility(comm)
        os.chdir(saveDir)
        print _(u"\nlamを停止しました。")

    #  reconstruct
    #    結果を再構築します
    def reconstruct(self):
        global caseDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        OFversion = pyTreeFoam.readConfigTreeFoam()[0]
        if OFversion >= "2.3.0":
            #OF-2.3以上
            if len(glob.glob("./constant/regionProperties")) != 0:
                #multiRegionの場合
                comm = "reconstructPar -allRegions -constant"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
            else:
                #singleRegionの場合
                comm = "reconstructPar -constant"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)

        else:
            #OF-2.2以下
            if len(glob.glob("./constant/regionProperties")) != 0:
                #multiRegionの場合
                [fluid, solid] = pyTreeFoam.getZonesInRegionProperties(caseDir)
                zones = fluid + solid
                for zone in zones:
                    comm = "reconstructPar -region " + zone + " -zeroTime"
                    print comm
                    [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                    if stat != "OK":
                        break
            else:
                #singleRegionの場合
                comm = "reconstructPar"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)

        if stat == "OK":
            title = _(u"結果の再構築")
            message = _(u"並列計算結果を再構築しました。")
            self.okDialog(title, message)
        else:
            title = _(u"エラー")
            message = _(u"結果の再構築中に、エラーが発生しました。\n  logを確認してください。")
            self.errDialog(title, message)
        os.chdir(saveDir)


    #------------------------------
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def warningDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_QUESTION) 
        dlg.ShowModal()
        dlg.Destroy()

# end of class MyFrame

#  getRegionCouplingPatch
#    DictからregionのcouplingPatchを取得
def getRegionCouplingPatch(caseDir, region):
    patches = []
    fileName = caseDir + "/system/" + region + "/decomposeParDict"
    f=open(fileName); cont=f.read(); f.close()
    [lineCont, p, kind] = getFoamContents.get1lineMem(cont, 0)
    [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    while lineCont != "" and keyword != "preservePatches":
        [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    if keyword == "preservePatches":
        [patchCont, pp] = getFoamContents.getSmallPairMem(lineCont, 0)
        patches = patchCont.split()
    return patches

#
#  setDecomposeCouplingPatch
#    cpuplingPatchの設定
def setDecomposeCouplingPatch(caseDir, regionCouplingPatches):

    #  deletePreservePatches
    def deletePreservePatches(caseDir, region):
        fileName = caseDir + "/system/" + region + "/decomposeParDict"
        f=open(fileName); cont=f.read(); f.close()
        ps = 0
        [lineCont, p, kind] = getFoamContents.get1lineMem(cont, 0)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        while lineCont != "" and keyword != "preservePatches":
            ps = p
            [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        if keyword == "preservePatches":
            newCont = cont[:ps] + cont[p:]
            f=open(fileName, "w"); f.write(newCont); f.close()

    #  setPreservePatches
    def setPreservePatches(caseDir, region, selPatches):
        fileName = caseDir + "/system/" + region + "/decomposeParDict"
        f=open(fileName); cont=f.read(); f.close()
        newLine = "preservePatches\n"
        newLine += "(\n"
        for patch in selPatches:
            newLine += "    " + patch + "\n"
        newLine += ");"
        [newCont, p, keyword] = getFoamContents.replace1lineMem(cont, 0, newLine)
        if keyword != "":
            f=open(fileName, "w"); f.write(newCont); f.close()
        else:
            [lineCont, p, kind] = getFoamContents.get1lineMem(cont, 0)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            while lineCont != "" and keyword != "numberOfSubdomains":
                [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
                [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            if keyword == "numberOfSubdomains":
                [chara, p] = getFoamContents.skipNoCharaMem(cont, p)
                newCont = cont[:p] + newLine + "\n\n" + cont[p:]
                f=open(fileName, "w"); f.write(newCont); f.close()

    #処理-----------
    for regionCouplingPatch in regionCouplingPatches:
        region = regionCouplingPatch[0]
        selPatches = regionCouplingPatch[1]
        if len(selPatches) == 0:
            deletePreservePatches(caseDir, region)
        else:
            setPreservePatches(caseDir, region, selPatches)


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]

    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
